#pragma once
#include <string>
#include <map>
#include <vector>


#ifdef _WINDOWS_COMPILE_
#ifndef  ASR_API
#define ASR_API _declspec(dllexport)
#endif
#else
#define ASR_API
#endif
class ASR_API KeyWordStruct
{
public:
	std::map<std::string, double> kws;
	KeyWordStruct();
	std::string toString();
};

class ASR_API HotWordStruct
{
public:
	int global_weight;
	std::vector<std::string> words;
	std::map<std::string, int> word_weights;
	HotWordStruct();
	std::string toString();
};

class ASR_API RecoderTranscriptionStruct
{
public:
	std::string app_key;
	std::string oss_link;
	std::string customization_id;
	bool auto_split;
	std::string vocabulary_id;
	struct ValidTimesParama
	{
		int begin_time;
		int end_time;
		int channel_id;
	};
	std::vector<ValidTimesParama> valid_times;
	bool enable_callback;
	std::string callback_url;
	std::string toString();
};


class ASR_API IRestfulRequest
{
public:
	IRestfulRequest();
	virtual ~IRestfulRequest();
	virtual std::string createRequest(std::string) = 0;
	virtual std::string getRequest(std::string) = 0;
	virtual std::string updateRequest(std::string, std::string) = 0;
	virtual std::string deleteRequest(std::string) = 0;
};

class ASR_API RestfulClient
{
public:
	enum RequestType
	{
		kws = 0,
		hw = 1,
		recoderTranscription  =2
	};
	RestfulClient(bool curlInitglobal = true, bool ssl = true);
	~RestfulClient();
	IRestfulRequest* createRestfulRequest(std::string url, std::string id, std::string secret,RequestType type);

private:
	bool _isInitalLibcurlGobal;
	bool _isInitalSSLGobal;
	IRestfulRequest* _request;
};
